'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _action_types = require('./action_types');

function merge(viewModelName, aggregateId, state) {
    return {
        type: _action_types.MERGE,
        viewModelName: viewModelName,
        aggregateId: aggregateId,
        state: state
    };
}

function sendCommand(_ref) {
    var command = _ref.command,
        aggregateId = _ref.aggregateId,
        aggregateName = _ref.aggregateName,
        payload = _ref.payload;

    return {
        type: _action_types.SEND_COMMAND,
        command: command,
        aggregateId: aggregateId,
        aggregateName: aggregateName,
        payload: payload
    };
}

function subscribe(viewModelName, aggregateId) {
    return {
        type: _action_types.SUBSCRIBE,
        viewModelName: viewModelName,
        aggregateId: aggregateId
    };
}

function unsubscribe(viewModelName, aggregateId) {
    return {
        type: _action_types.UNSUBSCRIBE,
        viewModelName: viewModelName,
        aggregateId: aggregateId
    };
}

function provideViewModels(viewModels) {
    return {
        type: _action_types.PROVIDE_VIEW_MODELS,
        viewModels: viewModels
    };
}

function disconnect(reason) {
    return {
        type: _action_types.DISCONNECT,
        reason: reason
    };
}

exports.default = {
    merge: merge,
    sendCommand: sendCommand,
    subscribe: subscribe,
    unsubscribe: unsubscribe,
    provideViewModels: provideViewModels,
    disconnect: disconnect
};