'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _is_loading_view_model = require('./is_loading_view_model');

var _is_loading_view_model2 = _interopRequireDefault(_is_loading_view_model);

var _actions = require('./actions');

var _actions2 = _interopRequireDefault(_actions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (mapStateToProps, mapDispatchToProps, mergeProps, options) {
    return function (Component) {
        var ConnectedComponent = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps, options)(Component);

        var ViewModelConnector = function (_React$PureComponent) {
            _inherits(ViewModelConnector, _React$PureComponent);

            function ViewModelConnector() {
                _classCallCheck(this, ViewModelConnector);

                return _possibleConstructorReturn(this, (ViewModelConnector.__proto__ || Object.getPrototypeOf(ViewModelConnector)).apply(this, arguments));
            }

            _createClass(ViewModelConnector, [{
                key: 'componentWillMount',
                value: function componentWillMount() {
                    var _mapStateToProps = mapStateToProps(this.context.store.getState(), this.props),
                        viewModelName = _mapStateToProps.viewModelName,
                        aggregateId = _mapStateToProps.aggregateId;

                    this.context.store.dispatch(_actions2.default.subscribe(viewModelName, aggregateId));

                    this.viewModelName = viewModelName;
                    this.aggregateId = aggregateId;
                }
            }, {
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    this.context.store.dispatch(_actions2.default.unsubscribe(this.viewModelName, this.aggregateId));
                }
            }, {
                key: 'render',
                value: function render() {
                    var loading = (0, _is_loading_view_model2.default)(this.context.store, this.viewModelName, this.aggregateId);

                    return _react2.default.createElement(ConnectedComponent, _extends({}, this.props, { loading: loading }));
                }
            }]);

            return ViewModelConnector;
        }(_react2.default.PureComponent);

        ViewModelConnector.contextTypes = {
            store: _propTypes2.default.object.isRequired
        };

        return ViewModelConnector;
    };
};