'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(store, action) {
        var command, aggregateId, aggregateName, payload, normalizedCommand, response, text;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        command = action.command, aggregateId = action.aggregateId, aggregateName = action.aggregateName, payload = action.payload;

                        if (command && (0, _util.checkRequiredFields)({ aggregateId: aggregateId, aggregateName: aggregateName }, 'Send command error:', JSON.stringify(action)) && !(command.ok || command.error)) {
                            _context.next = 3;
                            break;
                        }

                        return _context.abrupt('return');

                    case 3:
                        normalizedCommand = {
                            type: command.type,
                            aggregateId: aggregateId,
                            aggregateName: aggregateName,
                            payload: payload
                        };
                        _context.prev = 4;
                        _context.next = 7;
                        return (0, _isomorphicFetch2.default)((0, _util.getRootableUrl)('/api/commands'), {
                            method: 'POST',
                            headers: { 'Content-Type': 'application/json' },
                            credentials: 'same-origin',
                            body: JSON.stringify(normalizedCommand)
                        });

                    case 7:
                        response = _context.sent;

                        if (!response.ok) {
                            _context.next = 11;
                            break;
                        }

                        store.dispatch(_extends({}, action, {
                            command: _extends({}, action.command, {
                                ok: true
                            })
                        }));

                        return _context.abrupt('return');

                    case 11:
                        _context.next = 13;
                        return response.text();

                    case 13:
                        text = _context.sent;

                        // eslint-disable-next-line no-console
                        console.error('Send command error:', text);
                        throw new Error(text);

                    case 18:
                        _context.prev = 18;
                        _context.t0 = _context['catch'](4);

                        store.dispatch(_extends({}, action, {
                            command: _extends({}, action.command, {
                                error: _context.t0
                            })
                        }));

                    case 21:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[4, 18]]);
    }));

    function sendCommand(_x, _x2) {
        return _ref.apply(this, arguments);
    }

    return sendCommand;
}();