'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = subscribeAdapter;

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function subscribeAdapter() {
    var _onEvent = void 0,
        _onDisconnect = void 0;

    var socket = (0, _socket2.default)(window.location.origin, {
        path: (0, _util.getRootableUrl)('/socket/')
    });

    socket.on('event', function (event) {
        return _onEvent(JSON.parse(event));
    });

    socket.on('disconnect', function (reason) {
        return _onDisconnect(reason);
    });

    return {
        onEvent: function onEvent(callback) {
            _onEvent = callback;
        },
        onDisconnect: function onDisconnect(callback) {
            _onDisconnect = callback;
        },
        setSubscription: function setSubscription(_ref) {
            var aggregateIds = _ref.aggregateIds,
                types = _ref.types;

            socket.emit('setSubscription', {
                ids: aggregateIds, // TODO. Fix server-side
                types: types
            });
        }
    };
}